#!/usr/bin/env bash
set -Eeuo pipefail

cd "$(dirname "$(readlink -f "$BASH_SOURCE")")/specs"

versions=( "$@" )
if [ ${#versions[@]} -eq 0 ]; then
	versions=( */ )
fi
versions=( "${versions[@]%/}" )

suites=( "buster" "focal" "bullseye" "bookworm" )

variants=( "base" "jre11" "nightwatch-testing" "slim" "mobile-dev" )

generated_warning() {
	cat <<-EOH
		#
		# NOTE: THIS DOCKERFILE IS GENERATED VIA "update.sh"
		#
		# PLEASE DO NOT EDIT IT DIRECTLY.
		#

	EOH
}

gitlabSteps=
for version in "${versions[@]}"; do
	rcVersion="${version%-rc}"

	majorVersion="${rcVersion%%.*}"

	apiUrl="https://hub.docker.com/v2/repositories/library/node/tags?page_size=1000&page=1&name=$majorVersion.&ordering=last_updated"
    apiJqExpr='
        .results[]
        | select(.name | test("^'$majorVersion'\\.[0-9]+\\.[0-9]+$") )
        | [
            .name
        ]
    '

#    if [ "$rcVersion" != "$version" ]; then
#        apiXqExpr='
#            .rss
#            | .channel
#            | .item[]
#            | select(.title | startswith("'"$rcVersion"'.") and contains("'"rc"'") )
#            | [
#                .title
#            ]
#        '
#    fi
    IFS=$'\n'
    possibles=( $(
        curl -fsSL "$apiUrl" \
            | jq --raw-output "$apiJqExpr | @sh" \
            | sort -rV
    ) )
    unset IFS

    if [ "${#possibles[@]}" -eq 0 ]; then
        echo >&2
        echo >&2 "error: unable to determine available releases of $version"
        echo >&2
        exit 1
    fi

	# format of "possibles" array entries is "VERSION"
    eval "possi=( ${possibles[0]} )"
    fullVersion="${possi[0]}"

	dockerfiles=()

	for suite in "${suites[@]}"; do
		[ -d "$version/$suite" ] || continue
		alpineVer="${suite#alpine}"

		baseDockerfile=Dockerfile-debian.template
		if [ "${suite#alpine}" != "$suite" ]; then
			baseDockerfile=Dockerfile-alpine.template
		fi

	    pythonPackages="python3 python-is-python3"
    	if [ "${suite}" == "buster" ]; then
    		pythonPackages="python"
		fi

		for variant in "${variants[@]}"; do
			[ -d "$version/$suite/$variant" ] || continue
			{ generated_warning; cat "../templates/$baseDockerfile"; } > "$version/$suite/$variant/Dockerfile"

			imageVariant="${suite}-slim"
			echo "Generating $version/$suite/$variant/Dockerfile from $baseDockerfile + $variant-Dockerfile-block-*"
			gawk -i inplace -v variant="$variant" '
				$1 == "##</autogenerated>##" { ia = 0 }
				!ia { print }
				$1 == "##<autogenerated>##" { ia = 1; ab++; ac = 0; if (system("test -f ../templates/" variant "-Dockerfile-block-" ab) != 0) { ia = 0 } }
				ia { ac++ }
				ia && ac == 1 { system("cat ../templates/" variant "-Dockerfile-block-" ab) }
			' "$version/$suite/$variant/Dockerfile"

			echo -n "$fullVersion" > "$version/$suite/$variant/VERSION"

			cp -a \
				../templates/docker-entrypoint.sh \
				"$version/$suite/$variant/"

			# remove any _extra_ blank lines created by the deletions above
			gawk '
				{
					if (NF == 0 || (NF == 1 && $1 == "\\")) {
						blank++
					}
					else {
						blank = 0
					}

					if (blank < 2) {
						print
					}
				}
			' "$version/$suite/$variant/Dockerfile" > "$version/$suite/$variant/Dockerfile.new"
			mv "$version/$suite/$variant/Dockerfile.new" "$version/$suite/$variant/Dockerfile"

			sed -r \
				-e 's!%%DEBIAN_TAG%%!'"$suite-slim"'!' \
				-e 's!%%DEBIAN_SUITE%%!'"$suite"'!' \
				-e 's!%%ALPINE_VERSION%%!'"$alpineVer"'!' \
				-e 's!%%NODE_VERSION%%!'"$fullVersion"'!' \
				-e 's!%%IMAGE_VARIANT%%!'"$imageVariant"'!' \
				-e 's!%%PYTHON_PACKAGES%%!'"$pythonPackages"'!' \
				"$version/$suite/$variant/Dockerfile" > "$version/$suite/$variant/Dockerfile.new"
			mv "$version/$suite/$variant/Dockerfile.new" "$version/$suite/$variant/Dockerfile"
			dockerfiles+=( "$version/$suite/$variant/Dockerfile" )
		done
	done

	for dockerfile in "${dockerfiles[@]}"; do
		dir="${dockerfile%Dockerfile}"
		dir="${dir%/}"
		variant="${dir#$version}"
		variant="${variant#/}"
		newGitlabStep="\nbuild $version $variant:\n    extends:\n        - .docker-image-build\n    variables:\n        VERSION: '$version'\n        VARIANT: '$variant'"
		gitlabSteps="$gitlabSteps$newGitlabStep"
	done
done

gitlabCi=$(echo "$gitlabSteps" | awk '{gsub(/\\n/, "\n")}1')
echo "$gitlabCi" > ../.gitlab/docker-images.yml
